
;;;; Copyright (c) 1990, 1991 by the University of California, Irvine. 
;;;; This program may be freely copied, used, or modified provided that this
;;;; copyright notice is included in each copy of this code.  This program
;;;; may not be sold or incorporated into another product to be sold withou
;;;; written permission from the Regents of the University of California.
;;;; This program was written by Michael Pazzani, Cliff Brunk, Glenn Silverstien
;;;; and Kamal Ali.  

(in-package :user)

(def-type :atom a b c)
(def-type :list [] [a-b-c] [b-c] [c] )

(def-pred member
  :vars (?atom ?list)
  :type (:atom :list)
  :pos ( (a [a-b-c]) (b [a-b-c]) (c [a-b-c]) (b [b-c]) (c [b-c]) (c [c]) )
  :neg :computed
  )

(def-pred components
  :vars (?head ?rest ?list)
  :type (:atom :list :list)
  :pos ( (a [b-c] [a-b-c]) (b [c] [b-c]) (c [] [c]))
  )

(def-focl-problem member
  :max-new-variables 2
  )

(defun test-member (&optional trace)
  (focl 'member
        :max-new-variables 2
        :trace trace))